{
  lib,
  pkgs,
  config,
  ...
}:

{
  programs.kitty = {
    enable = true;
    shellIntegration.enableFishIntegration = true;
    themeFile = "gruvbox-dark";
    settings = {
      enable_audio_bell = false;
      confirm_os_window_close = 0; # no ask on quit
    };
    font = {
      package = pkgs.dejavu_fonts;
      name = "DejaVu Sans";
      size = 12;
    };
  };

  # home.shellAliases = {
  #   ssh = "kitten ssh"; # Copy kitten terminfo to remote
  # };

  home.sessionVariables.TERMINAL = lib.mkIf (config.terminal == "kitty") "kitty";
}
